package tools.descartes.prisma.agent.wildfly.callstack;

import java.util.Collection;
import java.util.Collections;

public class ComponentRecord {

	private final String serverNode;
	private final String component;
	private final String application;
	private final String module;
	private String componentClass = null;
	private String stringRepresentation;
	
	public ComponentRecord(String serverNode, String application, String module, String component) {
		this.serverNode = serverNode;
		this.application = application;
		this.module = module;
		this.component = component;
	}

	public static String getComponentIdentifier(String serverNode, String application, String module,
			String component) {
		StringBuilder name = new StringBuilder();
		if (serverNode != null && !serverNode.isEmpty()) {
			name.append(serverNode).append("/");
		}
		if (application != null && !application.isEmpty()) {
			name.append(application).append("/");
		}
		if (module != null && !module.isEmpty()) {
			name.append(module).append("/");
		}
		name.append(component);
		return name.toString();
	}

	public void setComponentClass(String componentClass) {
		this.componentClass = componentClass;
	}
	
	public String getComponentClass() {
		return componentClass;
	}
	
	public String getComponentName() {
		return component;
	}

	public String getServerNode() {
		return serverNode;
	}

	public String getApplication() {
		return application;
	}

	public String getModule() {
		return module;
	}

	public Collection<OperationRecord> getOperations() {
		return Collections.emptyList();
	}
	
	@Override
	public String toString() {
		if (stringRepresentation == null) {
			stringRepresentation = getComponentIdentifier(serverNode, application, module, component);
		}
		return stringRepresentation;
	}

}
