package tools.descartes.prisma.agent.wildfly.extension;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jboss.as.controller.AttributeDefinition;
import org.jboss.as.controller.PersistentResourceDefinition;
import org.jboss.as.controller.SimpleAttributeDefinitionBuilder;
import org.jboss.as.controller.registry.AttributeAccess;
import org.jboss.as.controller.registry.ManagementResourceRegistration;
import org.jboss.dmr.ModelNode;
import org.jboss.dmr.ModelType;

import tools.descartes.prisma.agent.wildfly.filters.FilterDefinition;
import tools.descartes.prisma.agent.wildfly.parameters.ParameterCharacterizationDefinition;

/**
 * @author <a href="mailto:tcerar@redhat.com">Tomaz Cerar</a>
 */
public class SubsystemDefinition extends PersistentResourceDefinition {
    public static final SubsystemDefinition INSTANCE = new SubsystemDefinition();

	public static final AttributeDefinition REPOSITORY = new SimpleAttributeDefinitionBuilder(
			SubsystemExtension.REPOSITORY_ATTRIBUTE, ModelType.STRING).setAllowExpression(true)
					.setXmlName(SubsystemExtension.REPOSITORY_ATTRIBUTE)
					.setFlags(AttributeAccess.Flag.RESTART_ALL_SERVICES).setDefaultValue(new ModelNode("127.0.0.1"))
					.setAllowNull(false).build();

    private SubsystemDefinition() {
        super(SubsystemExtension.SUBSYSTEM_PATH,
                SubsystemExtension.getResourceDescriptionResolver(null),
                //We always neeexid to add an 'add' operation
                SubsystemAdd.INSTANCE,
                //Every resource that is added, normally needs a remove operation
                SubsystemRemove.INSTANCE);
    }

    @Override
    public void registerOperations(ManagementResourceRegistration resourceRegistration) {
        super.registerOperations(resourceRegistration);
        //you can register aditional operations here
    }

    @Override
    public void registerAttributes(ManagementResourceRegistration resourceRegistration) {
        //you can register attributes here
    }

	@Override
	public Collection<AttributeDefinition> getAttributes() {
		return Arrays.asList(REPOSITORY);
	}
	
	@Override
	protected List<? extends PersistentResourceDefinition> getChildren() {
		return Arrays.asList(FilterDefinition.INSTANCE, ParameterCharacterizationDefinition.INSTANCE);
	}
}
