package tools.descartes.prisma.agent.wildfly.filters;

import java.util.regex.Pattern;

public class OperationPredicate {
	
	private final Pattern componentPattern;
	private final Pattern interfacePattern;
	private final Pattern operationPattern;
	
	public OperationPredicate(String componentRegex, String interfaceRegex, String operationRegex) {
		this.componentPattern = Pattern.compile(componentRegex);
		this.interfacePattern = Pattern.compile(interfaceRegex);
		this.operationPattern = Pattern.compile(operationRegex);
	}

	public boolean apply(String component, String interf, String operation) {
//		System.err.println("Filter operation: " + component + interf + operation);
		if (componentPattern.matcher(component).matches()) {
			if (interfacePattern.matcher(interf).matches()) {
				return operationPattern.matcher(operation).matches();
			}
		}
		return false;
	}
}
