package tools.descartes.prisma.agent.wildfly.interceptors;

import java.lang.reflect.Method;

import org.jboss.as.ee.component.ComponentDescription;
import org.jboss.invocation.InterceptorContext;

import tools.descartes.prisma.agent.wildfly.service.MonitoringService;

public class EJBRemoteCallInterceptor extends AbstractInterceptor {

	public EJBRemoteCallInterceptor(MonitoringService monitoringService, ComponentDescription component, String interf,
			Method method) {
		super(monitoringService, component.getComponentName(), component, interf, "rmi", method.getName());
	}

	@Override
	public Object processInvocation(InterceptorContext ctx) throws Exception {
		long startTime = System.nanoTime();
		startInvocation(ctx);
		try {
			return ctx.proceed();
		} finally {
			finishInvocation(startTime);
		}
	}

}
