package tools.descartes.prisma.agent.wildfly.parameters;

import java.util.Collection;

public class NullValueCharacterization implements ValueCharacterization {
	
	private final String name;
	private final int idx;
	private final String interfaceName;
	private final String operationName;
	
	public NullValueCharacterization(String interfaceName, String operationName, String name) {
		this(interfaceName, operationName, name, -1);
	}
	
	public NullValueCharacterization(String interfaceName, String operationName, String name, int idx) {
		this.name = name;
		this.idx = idx;
		this.interfaceName = interfaceName;
		this.operationName = operationName;
	}
	
	@Override
	public String getInterfaceName() {
		return interfaceName;
	}
	
	@Override
	public String getOperationName() {
		return operationName;
	}

	@Override
	public String getParameterName() {
		return name;
	}

	@Override
	public int getNumberOfValues() {
		return 2;
	}

	@Override
	public int getValueIndex(Object value) {
		if (value instanceof Collection) {
			return (value != null && !((Collection<?>)value).isEmpty()) ? 1 : 0;
		}
		return (value == null) ? 0 : 1;
	}
	
	@Override
	public String getValueIdentifier(int idx) {
		return (idx == 0) ? "Null" : "NotNull";
	}

	@Override
	public int getParameterIndex() {
		return idx;
	}

}
