package tools.descartes.prisma.agent.wildfly.parameters;

import java.util.Arrays;
import java.util.Collection;

import org.jboss.as.controller.AttributeDefinition;
import org.jboss.as.controller.PathElement;
import org.jboss.as.controller.PersistentResourceDefinition;
import org.jboss.as.controller.ReloadRequiredRemoveStepHandler;
import org.jboss.as.controller.SimpleAttributeDefinitionBuilder;
import org.jboss.as.controller.registry.AttributeAccess;
import org.jboss.dmr.ModelNode;
import org.jboss.dmr.ModelType;

import tools.descartes.prisma.agent.wildfly.extension.SubsystemExtension;
import tools.descartes.prisma.agent.wildfly.filters.FilterDefinition;

public class ParameterCharacterizationDefinition extends PersistentResourceDefinition {
	
	public static final AttributeDefinition INTERFACE =
            new SimpleAttributeDefinitionBuilder(SubsystemExtension.INTERFACE_PATTERN, ModelType.STRING)
                    .setAllowExpression(true)
                    .setXmlName(SubsystemExtension.INTERFACE_PATTERN)
                    .setFlags(AttributeAccess.Flag.RESTART_ALL_SERVICES)
                    .setDefaultValue(new ModelNode(".*"))
                    .setAllowNull(false)
                    .build();

	public static final AttributeDefinition OPERATION =
            new SimpleAttributeDefinitionBuilder(SubsystemExtension.OPERATION_PATTERN, ModelType.STRING)
                    .setAllowExpression(true)
                    .setXmlName(SubsystemExtension.OPERATION_PATTERN)
                    .setFlags(AttributeAccess.Flag.RESTART_ALL_SERVICES)
                    .setDefaultValue(new ModelNode(".*"))
                    .setAllowNull(false)
                    .build();
	
	public static final AttributeDefinition PARAMETER =
            new SimpleAttributeDefinitionBuilder(SubsystemExtension.PARAMETER, ModelType.STRING)
                    .setAllowExpression(true)
                    .setXmlName(SubsystemExtension.PARAMETER)
                    .setFlags(AttributeAccess.Flag.RESTART_ALL_SERVICES)
                    .setDefaultValue(new ModelNode(".*"))
                    .setAllowNull(false)
                    .build();

	public static final AttributeDefinition TYPE =
            new SimpleAttributeDefinitionBuilder(SubsystemExtension.CHARACTERIZATION_TYPE, ModelType.STRING)
                    .setAllowExpression(true)
                    .setXmlName(SubsystemExtension.CHARACTERIZATION_TYPE)
                    .setFlags(AttributeAccess.Flag.RESTART_ALL_SERVICES)
                    .setDefaultValue(new ModelNode(".*"))
                    .setAllowNull(false)
                    .build();
	public static final ParameterCharacterizationDefinition INSTANCE = new ParameterCharacterizationDefinition();
	
	private ParameterCharacterizationDefinition() {
		super(PathElement.pathElement(SubsystemExtension.PARAM_CHARACTERIZATION), SubsystemExtension.getResourceDescriptionResolver(SubsystemExtension.PARAM_CHARACTERIZATION), ParameterCharacterizationAdd.INSTANCE, ReloadRequiredRemoveStepHandler.INSTANCE);
	}

	@Override
	public Collection<AttributeDefinition> getAttributes() {
		return Arrays.asList(INTERFACE, OPERATION, PARAMETER, TYPE);
	}

}
