package tools.descartes.prisma.agent.wildfly.service;

import org.jboss.dmr.ModelNode;
import org.jboss.msc.service.Service;
import org.jboss.msc.service.StartContext;
import org.jboss.msc.service.StartException;
import org.jboss.msc.service.StopContext;

import tools.descartes.prisma.agent.wildfly.extension.SubsystemExtension;
import tools.descartes.prisma.agent.wildfly.filters.OperationPredicate;

public class FilterService implements Service<FilterService>  {
	
	private ModelNode definition;
	
	public FilterService(ModelNode definition) {
		this.definition = definition;
	}
	
	@Override
	public FilterService getValue() throws IllegalStateException, IllegalArgumentException {
		return this;
	}
	
	public OperationPredicate getPredicate() {
		ModelNode compPattern = definition.get(SubsystemExtension.COMPONENT_PATTERN);
		ModelNode intPattern = definition.get(SubsystemExtension.INTERFACE_PATTERN);
		ModelNode opPattern = definition.get(SubsystemExtension.OPERATION_PATTERN);
		System.err.println("FilterService: " + compPattern.asString() + " " + intPattern.asString() + " " + opPattern.asString());
		
		return new OperationPredicate(compPattern.asString(), intPattern.asString(), opPattern.asString());
	}

	@Override
	public void start(StartContext arg0) throws StartException {
		System.err.println("FitlerService started: " + definition.toJSONString(true));
	}

	@Override
	public void stop(StopContext arg0) {
		System.err.println("FitlerService stopped");
	}
}
