package tools.descartes.prisma.agent.wildfly.service;

import org.jboss.dmr.ModelNode;
import org.jboss.msc.service.Service;
import org.jboss.msc.service.StartContext;
import org.jboss.msc.service.StartException;
import org.jboss.msc.service.StopContext;

import tools.descartes.prisma.agent.wildfly.extension.SubsystemExtension;
import tools.descartes.prisma.agent.wildfly.parameters.NullValueCharacterization;
import tools.descartes.prisma.agent.wildfly.parameters.ValueCharacterization;

public class ParameterCharacterizationService implements Service<ParameterCharacterizationService> {
	
	private ModelNode definition;
	
	public ParameterCharacterizationService(ModelNode definition) {
		this.definition = definition;
	}

	@Override
	public ParameterCharacterizationService getValue() throws IllegalStateException, IllegalArgumentException {
		return this;
	}

	@Override
	public void start(StartContext arg0) throws StartException {
	}

	@Override
	public void stop(StopContext arg0) {
	}
	
	public ValueCharacterization createValueCharacterization() {
		ModelNode intPattern = definition.get(SubsystemExtension.INTERFACE_PATTERN);
		ModelNode opPattern = definition.get(SubsystemExtension.OPERATION_PATTERN);
		ModelNode param = definition.get(SubsystemExtension.PARAMETER);
		try {
			int idx = Integer.parseInt(param.asString());
			return new NullValueCharacterization(intPattern.asString(), opPattern.asString(), "p" + idx, idx);
		} catch(NumberFormatException ex) { }
		return new NullValueCharacterization(intPattern.asString(), opPattern.asString(),param.asString());
	}

}
