package tools.descartes.prisma.core.scopes;

import static org.fest.assertions.api.Assertions.assertThat;

import org.junit.Before;

import tools.descartes.prisma.core.TestMessageBus;
import tools.descartes.prisma.core.TestModelRepository;

public class HypervisorScopeTest extends ContainerScopeTest<VirtualInfrastructureScope> {

	private static final String NAME = "vsphere";

	@Before
	public void setUp() {
		name = "vsphere";
		messageBus = new TestMessageBus();
		repository = new TestModelRepository(messageBus);
		Scope scope = repository.getScope("hypervisor/" + NAME);
		assertThat(scope).isInstanceOf(VirtualInfrastructureScope.class);
		scope.create();
		this.scope = (VirtualInfrastructureScope) scope;
	}

}
