package tools.descartes.prisma.core.scopes;

import static org.fest.assertions.api.Assertions.assertThat;

import org.eclipse.emf.ecore.resource.Resource;
import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.mm.usageprofile.UsageProfile;
import tools.descartes.prisma.core.TestMessageBus;
import tools.descartes.prisma.core.TestModelRepository;

public class UsageProfileScopeTest extends ContainerScopeTest<UsageProfileScope> {

	@Before
	public void setUp() {
		name = "test";
		messageBus = new TestMessageBus();
		repository = new TestModelRepository(messageBus);
		repository.getSystemScope().create();
		Scope scope = repository.getScope(UsageProfileScope.USAGE_PROFILE_SCOPE_TYPE + "/" + name);
		assertThat(scope).isInstanceOf(UsageProfileScope.class);
		scope.create();
		this.scope = (UsageProfileScope) scope;
	}

	@Test
	public void testUsageProfile() {
		Resource usageProfileRes = repository.getResource(scope.getFolder() + "/" + name + ".usageprofile");
		assertThat(usageProfileRes).isNotNull();
		assertThat(usageProfileRes.getContents()).hasSize(1);
		UsageProfile usageProfile = (UsageProfile) usageProfileRes.getContents().get(0);
		assertThat(usageProfile).isNotNull();
		assertThat(usageProfile.getName()).isEqualTo(name);
		assertThat(usageProfile.getSystem()).isEqualTo(repository.getSystemScope().getSystem());
		assertThat(usageProfile.getUsageScenarios()).isEmpty();
	}

}
