package tools.descartes.prisma.core;

import java.util.List;

import org.eclipse.emf.ecore.resource.Resource;

import tools.descartes.prisma.core.scopes.Scope;
import tools.descartes.prisma.core.scopes.SystemGlobalScope;

public interface ModelRepository {

	public void connect();

	public void disconnect();

	public SystemGlobalScope getSystemScope();

	public Scope getScope(String path);

	public void createFolders(Transaction transaction, String path);

	public Resource getOrCreateResource(Transaction transaction, String path);

	public Resource getResource(String path);
	
	public List<String> listResources(String path);

	public boolean exists(String path);

	public Transaction createTransaction();
	
	public void waitForUpdate();

	public <T> List<T> query(String query, Object context, Class<T> resultType);

	public String getInstanceID(Object object);

	public Object getInstance(String id);
}
