package tools.descartes.prisma.core.scopes;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;

import tools.descartes.prisma.core.ModelRepository;

public class ModelNotification extends HashMap<String, Object> {

	// Expected value type: CDOID
	public static final String INSTANCE_ID = "INSTANCE_ID";

	// Expected value type: String
	public static final String INSTANCE_TYPE = "INSTANCE_TYPE";

	// Expected value type: NEW_NOTIFICATION, REMOVED_NOTIFICATION
	public static final String NOTIFICATION_TYPE = "NOTIFICATION_TYPE";

	public static final String NEW_NOTIFICATION = "NEW";

	public static final String REMOVED_NOTIFICATION = "REMOVED";

	private final ModelRepository repository;

	public ModelNotification(ModelRepository repository, Map<String, Object> headers) {
		super(headers);
		this.repository = repository;
	}

	public ModelNotification(ModelRepository repository, String notificationType, Class<?> instanceType,
			Object instance) {
		this.repository = repository;
		put(NOTIFICATION_TYPE, notificationType);
		put(INSTANCE_TYPE, instanceType.getName());
		put(INSTANCE_ID, repository.getInstanceID(instance));
	}

	public EObject getInstance() {
		return (EObject) repository.getInstance(get(INSTANCE_ID).toString());
	}


	public String getNotificationType() {
		return get(NOTIFICATION_TYPE).toString();
	}

}
