/**
 */
package tools.descartes.prisma.model.skeleton.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;

import edu.kit.ipd.descartes.mm.applicationlevel.system.SystemFactory;

import edu.kit.ipd.descartes.mm.deployment.DeploymentFactory;

import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory;

import edu.kit.ipd.descartes.mm.usageprofile.UsageProfileFactory;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.cdo.edit.CDOItemProviderAdapter;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.prisma.model.sensor.SensorFactory;

import tools.descartes.prisma.model.skeleton.ModelSkeleton;
import tools.descartes.prisma.model.skeleton.SkeletonPackage;

/**
 * This is the item provider adapter for a {@link tools.descartes.prisma.model.skeleton.ModelSkeleton} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ModelSkeletonItemProvider 
	extends CDOItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelSkeletonItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addAdaptationPointsPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Adaptation Points feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAdaptationPointsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ModelSkeleton_adaptationPoints_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ModelSkeleton_adaptationPoints_feature", "_UI_ModelSkeleton_type"),
				 SkeletonPackage.Literals.MODEL_SKELETON__ADAPTATION_POINTS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__USAGE_PROFILE);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__SYSTEM);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__REPOSITORY);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__DATA_CENTER);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__DEPLOYMENT);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__SENSORS);
			childrenFeatures.add(SkeletonPackage.Literals.MODEL_SKELETON__CONTAINERS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ModelSkeleton.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ModelSkeleton"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_ModelSkeleton_type");
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ModelSkeleton.class)) {
			case SkeletonPackage.MODEL_SKELETON__USAGE_PROFILE:
			case SkeletonPackage.MODEL_SKELETON__SYSTEM:
			case SkeletonPackage.MODEL_SKELETON__REPOSITORY:
			case SkeletonPackage.MODEL_SKELETON__DATA_CENTER:
			case SkeletonPackage.MODEL_SKELETON__DEPLOYMENT:
			case SkeletonPackage.MODEL_SKELETON__SENSORS:
			case SkeletonPackage.MODEL_SKELETON__CONTAINERS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__USAGE_PROFILE,
				 UsageProfileFactory.eINSTANCE.createUsageProfile()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__SYSTEM,
				 SystemFactory.eINSTANCE.createSystem()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__REPOSITORY,
				 RepositoryFactory.eINSTANCE.createRepository()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__DATA_CENTER,
				 ResourcelandscapeFactory.eINSTANCE.createDataCenter()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__DEPLOYMENT,
				 DeploymentFactory.eINSTANCE.createDeployment()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__SENSORS,
				 SensorFactory.eINSTANCE.createSensorRepository()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__CONTAINERS,
				 ResourcelandscapeFactory.eINSTANCE.createComputeNode()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__CONTAINERS,
				 ResourcelandscapeFactory.eINSTANCE.createStorageNode()));

		newChildDescriptors.add
			(createChildParameter
				(SkeletonPackage.Literals.MODEL_SKELETON__CONTAINERS,
				 ResourcelandscapeFactory.eINSTANCE.createRuntimeEnvironment()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SkeletonEditPlugin.INSTANCE;
	}

}
