/**
 */
package tools.descartes.prisma.model.scope;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.prisma.model.scope.ScopeFactory
 * @model kind="package"
 * @generated
 */
public interface ScopePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "scope";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/prisma/scope/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "scope";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ScopePackage eINSTANCE = tools.descartes.prisma.model.scope.impl.ScopePackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.scope.impl.ScopeConfigurationImpl <em>Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.scope.impl.ScopeConfigurationImpl
	 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getScopeConfiguration()
	 * @generated
	 */
	int SCOPE_CONFIGURATION = 0;

	/**
	 * The feature id for the '<em><b>Delegation Targets</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION__DELEGATION_TARGETS = 0;

	/**
	 * The feature id for the '<em><b>Agents</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION__AGENTS = 1;

	/**
	 * The feature id for the '<em><b>Delegated Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION__DELEGATED_OBJECTS = 2;

	/**
	 * The feature id for the '<em><b>Owned Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION__OWNED_OBJECTS = 3;

	/**
	 * The number of structural features of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_CONFIGURATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.scope.impl.ScopeReferenceImpl <em>Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.scope.impl.ScopeReferenceImpl
	 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getScopeReference()
	 * @generated
	 */
	int SCOPE_REFERENCE = 1;

	/**
	 * The feature id for the '<em><b>Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_REFERENCE__PATH = 0;

	/**
	 * The number of structural features of the '<em>Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_REFERENCE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_REFERENCE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.scope.impl.AgentImpl <em>Agent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.scope.impl.AgentImpl
	 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getAgent()
	 * @generated
	 */
	int AGENT = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT__ID = 0;

	/**
	 * The feature id for the '<em><b>Owned Objects</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT__OWNED_OBJECTS = 1;

	/**
	 * The number of structural features of the '<em>Agent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Agent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.scope.impl.DelegatedObjectImpl <em>Delegated Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.scope.impl.DelegatedObjectImpl
	 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getDelegatedObject()
	 * @generated
	 */
	int DELEGATED_OBJECT = 3;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATED_OBJECT__OBJECT = 0;

	/**
	 * The number of structural features of the '<em>Delegated Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATED_OBJECT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Delegated Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATED_OBJECT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.scope.impl.ObjectOwnershipImpl <em>Object Ownership</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.scope.impl.ObjectOwnershipImpl
	 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getObjectOwnership()
	 * @generated
	 */
	int OBJECT_OWNERSHIP = 4;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_OWNERSHIP__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Owners</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_OWNERSHIP__OWNERS = 1;

	/**
	 * The number of structural features of the '<em>Object Ownership</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_OWNERSHIP_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Object Ownership</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_OWNERSHIP_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.scope.ScopeConfiguration <em>Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configuration</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeConfiguration
	 * @generated
	 */
	EClass getScopeConfiguration();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.scope.ScopeConfiguration#getDelegationTargets <em>Delegation Targets</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Delegation Targets</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeConfiguration#getDelegationTargets()
	 * @see #getScopeConfiguration()
	 * @generated
	 */
	EReference getScopeConfiguration_DelegationTargets();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.scope.ScopeConfiguration#getAgents <em>Agents</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Agents</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeConfiguration#getAgents()
	 * @see #getScopeConfiguration()
	 * @generated
	 */
	EReference getScopeConfiguration_Agents();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.scope.ScopeConfiguration#getDelegatedObjects <em>Delegated Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Delegated Objects</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeConfiguration#getDelegatedObjects()
	 * @see #getScopeConfiguration()
	 * @generated
	 */
	EReference getScopeConfiguration_DelegatedObjects();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.scope.ScopeConfiguration#getOwnedObjects <em>Owned Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Objects</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeConfiguration#getOwnedObjects()
	 * @see #getScopeConfiguration()
	 * @generated
	 */
	EReference getScopeConfiguration_OwnedObjects();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.scope.ScopeReference <em>Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Reference</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeReference
	 * @generated
	 */
	EClass getScopeReference();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.model.scope.ScopeReference#getPath <em>Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Path</em>'.
	 * @see tools.descartes.prisma.model.scope.ScopeReference#getPath()
	 * @see #getScopeReference()
	 * @generated
	 */
	EAttribute getScopeReference_Path();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.scope.Agent <em>Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Agent</em>'.
	 * @see tools.descartes.prisma.model.scope.Agent
	 * @generated
	 */
	EClass getAgent();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.model.scope.Agent#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see tools.descartes.prisma.model.scope.Agent#getId()
	 * @see #getAgent()
	 * @generated
	 */
	EAttribute getAgent_Id();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.prisma.model.scope.Agent#getOwnedObjects <em>Owned Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Objects</em>'.
	 * @see tools.descartes.prisma.model.scope.Agent#getOwnedObjects()
	 * @see #getAgent()
	 * @generated
	 */
	EReference getAgent_OwnedObjects();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.scope.DelegatedObject <em>Delegated Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delegated Object</em>'.
	 * @see tools.descartes.prisma.model.scope.DelegatedObject
	 * @generated
	 */
	EClass getDelegatedObject();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.scope.DelegatedObject#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see tools.descartes.prisma.model.scope.DelegatedObject#getObject()
	 * @see #getDelegatedObject()
	 * @generated
	 */
	EReference getDelegatedObject_Object();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.scope.ObjectOwnership <em>Object Ownership</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Object Ownership</em>'.
	 * @see tools.descartes.prisma.model.scope.ObjectOwnership
	 * @generated
	 */
	EClass getObjectOwnership();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.scope.ObjectOwnership#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see tools.descartes.prisma.model.scope.ObjectOwnership#getObject()
	 * @see #getObjectOwnership()
	 * @generated
	 */
	EReference getObjectOwnership_Object();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.prisma.model.scope.ObjectOwnership#getOwners <em>Owners</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owners</em>'.
	 * @see tools.descartes.prisma.model.scope.ObjectOwnership#getOwners()
	 * @see #getObjectOwnership()
	 * @generated
	 */
	EReference getObjectOwnership_Owners();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ScopeFactory getScopeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.scope.impl.ScopeConfigurationImpl <em>Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.scope.impl.ScopeConfigurationImpl
		 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getScopeConfiguration()
		 * @generated
		 */
		EClass SCOPE_CONFIGURATION = eINSTANCE.getScopeConfiguration();

		/**
		 * The meta object literal for the '<em><b>Delegation Targets</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_CONFIGURATION__DELEGATION_TARGETS = eINSTANCE.getScopeConfiguration_DelegationTargets();

		/**
		 * The meta object literal for the '<em><b>Agents</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_CONFIGURATION__AGENTS = eINSTANCE.getScopeConfiguration_Agents();

		/**
		 * The meta object literal for the '<em><b>Delegated Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_CONFIGURATION__DELEGATED_OBJECTS = eINSTANCE.getScopeConfiguration_DelegatedObjects();

		/**
		 * The meta object literal for the '<em><b>Owned Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_CONFIGURATION__OWNED_OBJECTS = eINSTANCE.getScopeConfiguration_OwnedObjects();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.scope.impl.ScopeReferenceImpl <em>Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.scope.impl.ScopeReferenceImpl
		 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getScopeReference()
		 * @generated
		 */
		EClass SCOPE_REFERENCE = eINSTANCE.getScopeReference();

		/**
		 * The meta object literal for the '<em><b>Path</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCOPE_REFERENCE__PATH = eINSTANCE.getScopeReference_Path();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.scope.impl.AgentImpl <em>Agent</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.scope.impl.AgentImpl
		 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getAgent()
		 * @generated
		 */
		EClass AGENT = eINSTANCE.getAgent();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AGENT__ID = eINSTANCE.getAgent_Id();

		/**
		 * The meta object literal for the '<em><b>Owned Objects</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT__OWNED_OBJECTS = eINSTANCE.getAgent_OwnedObjects();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.scope.impl.DelegatedObjectImpl <em>Delegated Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.scope.impl.DelegatedObjectImpl
		 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getDelegatedObject()
		 * @generated
		 */
		EClass DELEGATED_OBJECT = eINSTANCE.getDelegatedObject();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELEGATED_OBJECT__OBJECT = eINSTANCE.getDelegatedObject_Object();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.scope.impl.ObjectOwnershipImpl <em>Object Ownership</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.scope.impl.ObjectOwnershipImpl
		 * @see tools.descartes.prisma.model.scope.impl.ScopePackageImpl#getObjectOwnership()
		 * @generated
		 */
		EClass OBJECT_OWNERSHIP = eINSTANCE.getObjectOwnership();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBJECT_OWNERSHIP__OBJECT = eINSTANCE.getObjectOwnership_Object();

		/**
		 * The meta object literal for the '<em><b>Owners</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBJECT_OWNERSHIP__OWNERS = eINSTANCE.getObjectOwnership_Owners();

	}

} //ScopePackage
