/**
 */
package tools.descartes.prisma.model.sensor;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.prisma.model.sensor.SensorFactory
 * @model kind="package"
 * @generated
 */
public interface SensorPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "sensor";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/prisma/sensor/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "sensor";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SensorPackage eINSTANCE = tools.descartes.prisma.model.sensor.impl.SensorPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.sensor.impl.SensorRepositoryImpl <em>Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.sensor.impl.SensorRepositoryImpl
	 * @see tools.descartes.prisma.model.sensor.impl.SensorPackageImpl#getSensorRepository()
	 * @generated
	 */
	int SENSOR_REPOSITORY = 0;

	/**
	 * The feature id for the '<em><b>Sensors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_REPOSITORY__SENSORS = 0;

	/**
	 * The number of structural features of the '<em>Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_REPOSITORY_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.sensor.impl.SensorImpl <em>Sensor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.sensor.impl.SensorImpl
	 * @see tools.descartes.prisma.model.sensor.impl.SensorPackageImpl#getSensor()
	 * @generated
	 */
	int SENSOR = 1;

	/**
	 * The feature id for the '<em><b>Agent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR__AGENT = 0;

	/**
	 * The feature id for the '<em><b>Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR__ENTITY = 1;

	/**
	 * The feature id for the '<em><b>Metric</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR__METRIC = 2;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR__UNIT = 3;

	/**
	 * The feature id for the '<em><b>Aggregation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR__AGGREGATION = 4;

	/**
	 * The number of structural features of the '<em>Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.sensor.SensorRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Repository</em>'.
	 * @see tools.descartes.prisma.model.sensor.SensorRepository
	 * @generated
	 */
	EClass getSensorRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.sensor.SensorRepository#getSensors <em>Sensors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sensors</em>'.
	 * @see tools.descartes.prisma.model.sensor.SensorRepository#getSensors()
	 * @see #getSensorRepository()
	 * @generated
	 */
	EReference getSensorRepository_Sensors();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.sensor.Sensor <em>Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sensor</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor
	 * @generated
	 */
	EClass getSensor();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.sensor.Sensor#getAgent <em>Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Agent</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor#getAgent()
	 * @see #getSensor()
	 * @generated
	 */
	EReference getSensor_Agent();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.sensor.Sensor#getEntity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor#getEntity()
	 * @see #getSensor()
	 * @generated
	 */
	EReference getSensor_Entity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.sensor.Sensor#getMetric <em>Metric</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Metric</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor#getMetric()
	 * @see #getSensor()
	 * @generated
	 */
	EReference getSensor_Metric();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.sensor.Sensor#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Unit</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor#getUnit()
	 * @see #getSensor()
	 * @generated
	 */
	EReference getSensor_Unit();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.model.sensor.Sensor#getAggregation <em>Aggregation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Aggregation</em>'.
	 * @see tools.descartes.prisma.model.sensor.Sensor#getAggregation()
	 * @see #getSensor()
	 * @generated
	 */
	EAttribute getSensor_Aggregation();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SensorFactory getSensorFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.sensor.impl.SensorRepositoryImpl <em>Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.sensor.impl.SensorRepositoryImpl
		 * @see tools.descartes.prisma.model.sensor.impl.SensorPackageImpl#getSensorRepository()
		 * @generated
		 */
		EClass SENSOR_REPOSITORY = eINSTANCE.getSensorRepository();

		/**
		 * The meta object literal for the '<em><b>Sensors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SENSOR_REPOSITORY__SENSORS = eINSTANCE.getSensorRepository_Sensors();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.sensor.impl.SensorImpl <em>Sensor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.sensor.impl.SensorImpl
		 * @see tools.descartes.prisma.model.sensor.impl.SensorPackageImpl#getSensor()
		 * @generated
		 */
		EClass SENSOR = eINSTANCE.getSensor();

		/**
		 * The meta object literal for the '<em><b>Agent</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SENSOR__AGENT = eINSTANCE.getSensor_Agent();

		/**
		 * The meta object literal for the '<em><b>Entity</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SENSOR__ENTITY = eINSTANCE.getSensor_Entity();

		/**
		 * The meta object literal for the '<em><b>Metric</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SENSOR__METRIC = eINSTANCE.getSensor_Metric();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SENSOR__UNIT = eINSTANCE.getSensor_Unit();

		/**
		 * The meta object literal for the '<em><b>Aggregation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SENSOR__AGGREGATION = eINSTANCE.getSensor_Aggregation();

	}

} //SensorPackage
