/**
 */
package tools.descartes.prisma.model.skeleton;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.prisma.model.skeleton.SkeletonFactory
 * @model kind="package"
 * @generated
 */
public interface SkeletonPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "skeleton";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/prisma/skeleton/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "skeleton";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SkeletonPackage eINSTANCE = tools.descartes.prisma.model.skeleton.impl.SkeletonPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.model.skeleton.impl.ModelSkeletonImpl <em>Model Skeleton</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.model.skeleton.impl.ModelSkeletonImpl
	 * @see tools.descartes.prisma.model.skeleton.impl.SkeletonPackageImpl#getModelSkeleton()
	 * @generated
	 */
	int MODEL_SKELETON = 0;

	/**
	 * The feature id for the '<em><b>Usage Profile</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__USAGE_PROFILE = 0;

	/**
	 * The feature id for the '<em><b>System</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__SYSTEM = 1;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__REPOSITORY = 2;

	/**
	 * The feature id for the '<em><b>Data Center</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__DATA_CENTER = 3;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__DEPLOYMENT = 4;

	/**
	 * The feature id for the '<em><b>Adaptation Points</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__ADAPTATION_POINTS = 5;

	/**
	 * The feature id for the '<em><b>Sensors</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__SENSORS = 6;

	/**
	 * The feature id for the '<em><b>Containers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON__CONTAINERS = 7;

	/**
	 * The number of structural features of the '<em>Model Skeleton</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON_FEATURE_COUNT = 8;

	/**
	 * The number of operations of the '<em>Model Skeleton</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SKELETON_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton <em>Model Skeleton</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Skeleton</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton
	 * @generated
	 */
	EClass getModelSkeleton();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getUsageProfile <em>Usage Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Usage Profile</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getUsageProfile()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_UsageProfile();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getSystem <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>System</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getSystem()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_System();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Repository</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getRepository()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_Repository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getDataCenter <em>Data Center</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Center</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getDataCenter()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_DataCenter();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deployment</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getDeployment()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_Deployment();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getAdaptationPoints <em>Adaptation Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Adaptation Points</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getAdaptationPoints()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_AdaptationPoints();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getSensors <em>Sensors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sensors</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getSensors()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_Sensors();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.model.skeleton.ModelSkeleton#getContainers <em>Containers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Containers</em>'.
	 * @see tools.descartes.prisma.model.skeleton.ModelSkeleton#getContainers()
	 * @see #getModelSkeleton()
	 * @generated
	 */
	EReference getModelSkeleton_Containers();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SkeletonFactory getSkeletonFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.model.skeleton.impl.ModelSkeletonImpl <em>Model Skeleton</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.model.skeleton.impl.ModelSkeletonImpl
		 * @see tools.descartes.prisma.model.skeleton.impl.SkeletonPackageImpl#getModelSkeleton()
		 * @generated
		 */
		EClass MODEL_SKELETON = eINSTANCE.getModelSkeleton();

		/**
		 * The meta object literal for the '<em><b>Usage Profile</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__USAGE_PROFILE = eINSTANCE.getModelSkeleton_UsageProfile();

		/**
		 * The meta object literal for the '<em><b>System</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__SYSTEM = eINSTANCE.getModelSkeleton_System();

		/**
		 * The meta object literal for the '<em><b>Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__REPOSITORY = eINSTANCE.getModelSkeleton_Repository();

		/**
		 * The meta object literal for the '<em><b>Data Center</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__DATA_CENTER = eINSTANCE.getModelSkeleton_DataCenter();

		/**
		 * The meta object literal for the '<em><b>Deployment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__DEPLOYMENT = eINSTANCE.getModelSkeleton_Deployment();

		/**
		 * The meta object literal for the '<em><b>Adaptation Points</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__ADAPTATION_POINTS = eINSTANCE.getModelSkeleton_AdaptationPoints();

		/**
		 * The meta object literal for the '<em><b>Sensors</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__SENSORS = eINSTANCE.getModelSkeleton_Sensors();

		/**
		 * The meta object literal for the '<em><b>Containers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SKELETON__CONTAINERS = eINSTANCE.getModelSkeleton_Containers();

	}

} //SkeletonPackage
